"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.transformArguments = exports.FIRST_KEY_INDEX = void 0;
exports.FIRST_KEY_INDEX = 1;
function transformArguments(...[key, value, fieldValue]) {
    const args = ['HSET', key];
    if (typeof value === 'string') {
        args.push(value, fieldValue);
    }
    else if (value instanceof Map) {
        pushMap(args, value);
    }
    else if (Array.isArray(value)) {
        pushTuples(args, value);
    }
    else if (typeof value === 'object' && value !== null) {
        pushObject(args, value);
    }
    return args;
}
exports.transformArguments = transformArguments;
function pushMap(args, map) {
    for (const [key, value] of map.entries()) {
        args.push(key.toString(), value.toString());
    }
}
function pushTuples(args, tuples) {
    args.push(...tuples.flat());
}
function pushObject(args, object) {
    for (const key of Object.keys(object)) {
        args.push(key.toString(), object[key].toString());
    }
}
